<template>
  <div class="reg_bar">
    <ErrorNotify />
    <div class="multi_step">
      <div class="ring">
        <span v-show="!complited">1</span>
        <img v-show="complited" src="@/assets/signin/check.svg" />
      </div>
      <div class="road">
        <div class="road_color"></div>
      </div>
      <div class="ring">
        <span v-show="!complited2">2</span>
        <img v-show="complited2" src="@/assets/signin/check.svg" />
      </div>
      <div class="road">
        <div class="road_color"></div>
      </div>
      <div class="ring"><span>3</span></div>
    </div>
    <div v-show="isActive" class="data">
      <label>Username</label>
      <input type="text" placeholder="Name" v-model="name" />

      <label>Email</label>
      <input type="email" placeholder="Email" v-model="email" />

      <label>Password</label>
      <input type="password" placeholder="Password" v-model="password" />
      <div class="send-btn reg-btn">
        <button @click="VerifyEmail(name, email, password)">Next</button>
      </div>
    </div>
    <div
      v-show="agenActive"
      :class="{ animate__zoomIn: isActive }"
      class="ageGender animate__animated"
    >
      <p class="agend">Select your age and gender</p>
      <ul>
        <li :class="{ selected: '1' == picked }">
          <input type="radio" id="one" value="1" v-model="picked" />
          <label for="one">Less than 18</label>
        </li>
        <li :class="{ selected: '2' == picked }">
          <input type="radio" id="two" value="2" v-model="picked" />
          <label for="two"> 18 - 24</label>
        </li>
        <li :class="{ selected: '3' == picked }">
          <input type="radio" id="thre" value="3" v-model="picked" />
          <label for="thre">25 - 30</label>
        </li>
        <li :class="{ selected: '4' == picked }">
          <input type="radio" id="four" value="4" v-model="picked" />
          <label for="four">31 - 40</label>
        </li>
        <li :class="{ selected: '5' == picked }">
          <input type="radio" id="five" value="5" v-model="picked" />
          <label for="five">Over 41</label>
        </li>
      </ul>
      <div class="gender">
        <div class="gen_box">
          <img src="@/assets/signin/male.png" />
          <div class="gen" :class="{ selected: '6' == gen }">
            <input type="radio" id="six" value="6" v-model="gen" />
            <label for="six">Male</label>
          </div>
        </div>
        <div class="gen_box">
          <img src="@/assets/signin/female.png" />
          <div class="gen" :class="{ selected: '7' == gen }">
            <input type="radio" id="seven" value="7" v-model="gen" />
            <label for="seven">Female</label>
          </div>
        </div>
      </div>
      <div class="row btns">
        <button class="reg col-5" @click="secondPrevious()">Previous</button>
        <div class="col-2"></div>
        <button
          :class="{ disabled: disabled }"
          class="reg col-5"
          :disabled="disabled"
          @click="secondNext()"
        >
          Next
        </button>
      </div>
    </div>
    <div
      v-show="showNum"
      :class="{ animate__fadeInRight: showNum }"
      class="verifynum animate__animated"
    >
      <label class="verifynumLab">Please write verifycation number</label>
      <input
        type="text"
        placeholder="Number"
        maxlength="6"
        v-model="verifynum"
      />
      <div class="btns row">
        <button class="reg col-5" @click="Previous()">Previous</button>
        <div class="col-2"></div>
        <button
          :class="{ disabled: createDisable }"
          class="reg col-5"
          :disabled="createDisable"
          @click="VerifyNum()"
        >
          Create
        </button>
      </div>
    </div>
  </div>
</template>
<script>
import ErrorNotify from "../ErrorNotify/ErrorNotify";
import { mapGetters } from "vuex";
export default {
  components: {
    ErrorNotify,
  },
  data() {
    return {
      picked: null,
      gen: null,
      name: "",
      email: "",
      password: "",
      agenActive: false,
      showNum: false,
      verifynum: "",
      complited: false,
      complited2: false,
      disabled: true,
      createDisable: true,
      regNum: /^[0-9]+$/,
    };
  },
  computed: {
    ...mapGetters(["reg", "isActive", "axios"]),
    agen() {
      return [this.picked, this.gen];
    },
  },
  methods: {
    VerifyEmail(verifyName, verifyEmail, verifyPass) {
      if (!verifyName || !verifyEmail || !verifyPass) {
        this.$store.commit("Erralert", "Please fill in the inputs!");
      } else if (!this.reg.test(verifyEmail)) {
        this.$store.commit("Erralert", "Please write correct email!");
      } else if (!(verifyPass.length >= 8)) {
        this.$store.commit(
          "Erralert",
          "Please write an 8-digit or more password!"
        );
      } else {
        this.axios
          .post("register", {
            email: verifyEmail,
          })
          .catch(() => {
            this.$store.commit("Erralert", "ERROR: 505");
          });
        this.$store.state.isActive = false;
        this.agenActive = true;
        this.complited = true;
      }
    },
    VerifyNum() {
      this.axios
        .post("signup", {
          num: this.verifynum,
          name: this.name,
          email: this.email,
          psw: this.password,
          age: this.picked,
          gen: this.gen,
        })
        .catch(() => {
          this.$store.commit("Erralert", "ERROR: 505");
        });
      this.$router.push({ path: "/login" });
    },
    secondNext() {
      this.agenActive = false;
      this.showNum = true;
      this.complited2 = true;
    },
    Previous() {
      this.agenActive = true;
      this.showNum = false;
    },
    secondPrevious() {
      this.$store.state.isActive = true;
      this.agenActive = false;
    },
  },
  watch: {
    verifynum() {
      if (this.verifynum.length == 6 && this.regNum.test(this.verifynum)) {
        this.createDisable = false;
      } else {
        this.createDisable = true;
      }
    },
    agen() {
      if (typeof (this.picked && this.gen) === "string") {
        this.disabled = false;
      }
    },
  },
};
</script>
<style lang="scss">
@import "signup.scss";
</style>